package org.aksw.iguana.cc.worker.impl;

import org.aksw.iguana.cc.config.elements.Connection;
import org.aksw.iguana.commons.annotation.Nullable;
import org.aksw.iguana.commons.annotation.Shorthand;

import java.io.UnsupportedEncodingException;

@Shorthand("CypherWorker")
public class CypherWorker extends HttpPostWorker {

    private static final String contentType = "application/json";
    private static final String responseType = "application/json";

    public CypherWorker(String taskID, Connection connection, String queriesFile, @Nullable String parameterName, @Nullable Integer timeOut, @Nullable Integer timeLimit, @Nullable Integer fixedLatency, @Nullable Integer gaussianLatency, Integer workerID) {
        super(taskID, connection, queriesFile, contentType, responseType, parameterName, "lang.SIMPLE", timeOut, timeLimit, fixedLatency, gaussianLatency, "CypherWorker", workerID);
    }

    @Override
    void buildRequest(String query, String queryID) throws UnsupportedEncodingException {
        super.buildRequest(String.format("{ \"statements\": [{ \"statement\": \"%s\", \"resultDataContents\": [ \"rest\" ] } ] }", query), queryID);
    }
}
